uab = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "FuBarPlugin-2.0", "Metrognome-2.0", "AceModuleCore-2.0")
uab:SetModuleMixins("AceDebug-2.0", "AceEvent-2.0", "AceModuleCore-2.0")
uab:RegisterDB("UABDB")

function uab.modulePrototype:OnInitialize()
	if not self.db then
		self.core:RegisterDefaults(self.name, "profile", self.defaultDB or {})
		self.db = self.core:AcquireDBNamespace(self.name)
	end
end

function uab.modulePrototype:OnEnable()
end

uab.hasIcon = "Interface\\CURSOR\\\Cast"
uab.defaultPosition = "RIGHT"
uab.hideWithoutStandby = true
uab.independentProfile = true
uab.hasNoColor = true
uab.cannotDetachTooltip = true

uab.constants = {}
uab.classes = {}
uab.interfaces = {}
uab.mixins = {}
uab.modules = {}

uab.constants.buttonWidth = 38
uab.constants.buttonHeight = 38
uab.constants.controlsperunit = 3
uab.constants.groupInfo = {
	player = { name = "player", unitcount = 1, displayName = "Player", minstate = 100, maxstate = 199 },
	pet = { name = "pet", unitcount = 1, displayName = "Pet", minstate = 200, maxstate = 299 },
	target = { name = "target", unitcount = 1, displayName = "Target", minstate = 300, maxstate = 399 },
	targettarget = { name = "targettarget", unitcount = 1, displayName = "Target of Target", minstate = 400, maxstate = 499 },
	targettargettarget = { name = "targettargettarget", unitcount = 1, displayName = "ToT Target", minstate = 500, maxstate = 599 },
	focus = { name = "focus", unitcount = 1, displayName = "Focus", minstate = 600, maxstate = 599 },
	focustarget = { name = "focustarget", unitcount = 1, displayName = "Focus Target", minstate = 700, maxstate = 799 },
	partyraid = { name = "partyraid", unitcount = 60, displayName = "Party/Raid", minstate = 1001, maxstate = 2000 },
}
uab.constants.maxactivatorcontrols = 3000

uab.constants.grow = {}
uab.constants.grow.up = "u"
uab.constants.grow.down = "d"
uab.constants.grow.left = "l"
uab.constants.grow.right = "r"

uab.constants.placement = {}
uab.constants.placement.left = "l"
uab.constants.placement.topleft = "tl"
uab.constants.placement.top = "t"
uab.constants.placement.topright = "tr"
uab.constants.placement.right = "r"
uab.constants.placement.bottomright = "br"
uab.constants.placement.bottom = "b"
uab.constants.placement.bottomleft = "bl"

uab.constants.anchor = {}
uab.constants.anchor.top = "top"
uab.constants.anchor.left = "left"

uab.layoutManagers = {}
uab.unitEffectClasses = {}
uab.unitEffectClassInstances = {}

function uab.print(msg)
    if msg then DEFAULT_CHAT_FRAME:AddMessage(msg) end
end

--uab.debug = true
--uab.savedebug = true

function uab.pdebug(msg)
    if uab.debug and msg then
        if uab.savedebug then
            table.insert(UABDebug, msg)
        else
            DEFAULT_CHAT_FRAME:AddMessage(msg)
        end
    end
end

function uab.SetFrameAttribute(frame, attrib, val, state)
    frame:SetAttribute(attrib, val)
    
    if not val then
        val = "nil"
    end

    local parent = frame:GetParent()
    if not parent then
        parent = "UIParent"
    else
        parent = parent:GetName()
        if not parent then
            parent = "unnamed parent"
        end
    end
    
    frame = frame:GetName()
    if not frame then
        frame = "unnamed frame"
    end

    if state then
        uab.pdebug("SetAttribute("..state.."): frame = "..frame..", parent = "..parent..", attribute = "..attrib..", val = "..val)
    else
        uab.pdebug("SetAttribute: frame = "..frame..", parent = "..parent..", attribute = "..attrib..", val = "..val)
    end
end

function uab.SetBoolFrameAttribute(frame, attrib, val, state)
    frame:SetAttribute(attrib, val)
    
    if not val then
        val = "nil"
    elseif val == true then
        val = "true"
    else
        val = "false"
    end

    local parent = frame:GetParent()
    if not parent then
        parent = "UIParent"
    else
        parent = parent:GetName()
        if not parent then
            parent = "unnamed parent"
        end
    end
    
    frame = frame:GetName()
    if not frame then
        frame = "unnamed frame"
    end

    if state then
        uab.pdebug("SetAttribute("..state.."): frame = "..frame..", parent = "..parent..", attribute = "..attrib..", val = "..val)
    else
        uab.pdebug("SetAttribute: frame = "..frame..", parent = "..parent..", attribute = "..attrib..", val = "..val)
    end
end

function uab.SetFrameFrameAttribute(frame, attrib, val, state)
    frame:SetAttribute(attrib, val)
    
    if not val then
        val = "nil"
    else
        val = val:GetName()
        if not val then
            val = "unnamed frame"
        end
    end

    local parent = frame:GetParent()
    if not parent then
        parent = "UIParent"
    else
        parent = parent:GetName()
        if not parent then
            parent = "unnamed parent"
        end
    end
    
    frame = frame:GetName()
    if not frame then
        frame = "unnamed frame"
    end

    if state then
        uab.pdebug("SetAttribute("..state.."): frame = "..frame..", parent = "..parent..", attribute = "..attrib..", val = "..val)
    else
        uab.pdebug("SetAttribute: frame = "..frame..", parent = "..parent..", attribute = "..attrib..", val = "..val)
    end
end

UABDebug = {}

uab.mixins.aceDB = AceLibrary("AceDB-2.0")
uab.mixins.aceEvent = AceLibrary("AceEvent-2.0")
uab.mixins.aceOO = AceLibrary("AceOO-2.0")
uab.mixins.aura = AceLibrary("SpecialEvents-Aura-2.0")
uab.mixins.banzai = AceLibrary("Banzai-1.1")
uab.mixins.tablet = AceLibrary("Tablet-2.0")

uab.interfaces.IUnitEffect = uab.mixins.aceOO.Interface {
	GetName = "function",
	GetDisplayName = "function",
	GetDefaultHighlightColor = "function",
    IsActive = "function",
}

uab.interfaces.IActionData = uab.mixins.aceOO.Interface {
    IsUsable = "function",
	GetAttributes = "function",
	GetClassName = "function",
	GetIcon = "function",
	GetText = "function",
    GetCount = "function",
    GetCooldown = "function",
	SetTooltip = "function",
}

uab.interfaces.IActionSetLayout = uab.mixins.aceOO.Interface {
	ArrangeButtons = "function",
	GetConfig = "function",
	SetSettings = "function",
}

uab.interfaces.IActionSetLayoutConfig = uab.mixins.aceOO.Interface {
	GetFrame = "function", -- GetFrame()
	SettingsChanged = "function", -- SettingsChanged(settings) or SettingsChanged()
	UseDefaults = "function", -- UseDefaults()
	MenuOptionArgs = "function", -- MenuOptionArgs()
}

uab.interfaces.IActionSetLayoutManager = uab.mixins.aceOO.Interface {
	GetLayout = "function",
	GetName = "function",
	GetDisplayName = "function",
}
		 		 
--[[
Default profile configuration settings
--]]
uab.profileDefaults = {
    tooltips = true,
    directcast = true,
    fastchangeunit = true,
    checkusable = true,
    blinkcycle = 1.0,
    borderwidth = 2,
    alpha = 0.5,
    activators = {
    },
    groupstayopen = {
    },
    independent = {
    },
    framegroups = {
    },
    scale = {
        player = {
			usedefault = true,
		},
        pet = {
			usedefault = true,
		},
        partyraid = {
			usedefault = true,
		},
        focus = {
			usedefault = true,
		},
        focustarget = {
			usedefault = true,
		},
        target = {
			usedefault = true,
		},
        targettarget = {
			usedefault = true,
		},
        targettargettarget = {
			usedefault = true,
		},
        default = {
			value = 1.0,
		},
    },
    position = {
        player = {
			usedefault = true,
		},
        pet = {
			usedefault = true,
		},
        partyraid = {
			usedefault = true,
		},
        focus = {
			usedefault = true,
		},
        focustarget = {
			usedefault = true,
		},
        target = {
			usedefault = true,
		},
        targettarget = {
			usedefault = true,
		},
        targettargettarget = {
			usedefault = true,
		},
        default = {
			point = "CENTER",
            relpoint = "cursor",
            x = 0.0,
            y = 0.0,
		},
    },
    layout = "uab.Bar",
}

--[[
Constant menu/slash commands.
--]]
uab.options = {
    type = 'group',
    args = {
        actionsets = {
            type = 'group',
            name = "Action Sets",
            desc = "Create, modify, and remove action sets",
            disabled = function() return InCombatLockdown() end,
    		order = 10,
            args = {},
        },
        
        lookandfeel = {
            type = 'group',
            name = "Look and Feel",
            desc = "Options that affect how buttons appear.  Includes layout, positioning, scaling, and button behavior",
            disabled = function() return InCombatLockdown() end,
    		order = 20,
            args = {
                layout = {
                    type = 'group',
                    name = "Layout",
                    desc = "Select and configure button layout options",
            		order = 10,
                    args = {
                        configure = {
                            type = 'group',
                            name = "Configure",
                            desc = "Configure current layout options",
                            order = 10,
                            args = {}
                        },
                        select = {
        	                type = 'text',
        	                name = "Select",
        	                usage = "<name>",
        	                desc = "Select the current layout to use",
                            order = 20,
        	                get = function()
        					    local managers = uab:GetManagers()
        					    local mgr = managers[uab.db.profile.layout].manager
        					    
        					    return mgr:GetDisplayName()
        					end,
        	                set = function(name)
        					    local managers = uab:GetManagers()
        
        						for _, mgr in pairs(managers) do
        						    if mgr.manager:GetDisplayName() == name then
        								uab.db.profile.layout = mgr.manager:GetName()
        								uab.main:LayoutChanged()
        								break
        							end
        						end
        	                end,
                        },
                    },
                },

                spacing1 = {
            		name = " ",
            		type = 'header',
            		order = 21,
            	},
            
                spacing2 = {
            		name = "Button Appearance",
            		type = 'header',
            		order = 22,
            	},
                
                defaultanchorscale = {
                    type = 'group',
                    name = "Default",
                    desc = "Default action button anchor and scale",
            		order = 30,
                    args = {
                        scale = {
                            type = 'range',
                            name = "Scale",
                            desc = "Default action button scale",
                            order = 5,
                            min = 0.05,
                            max = 2.00,
                            step = 0.05,
                            isPercent = true,
                            get = function()
                                return uab.db.profile.scale.default.value
                            end,
                            set = function(value)
                                uab.db.profile.scale.default.value = value
                                uab.main:ScaleChanged()
                            end,
                        },
                        point = {
                            type = 'text',
                            name = "Point",
                            usage = "<name>",
                            desc = "Select the point on the cancel button that positioning in based from",
                            order = 10,
                            get = function()
                                return uab.db.profile.position.default.point
                            end,
                            set = function(pt)
                                uab.db.profile.position.default.point = pt
                            end,
                            validate = {
                                "BOTTOM",
                                "BOTTOMLEFT",
                                "BOTTOMRIGHT",
                                "CENTER",
                                "LEFT",
                                "RIGHT",
                                "TOP",
                                "TOPLEFT",
                                "TOPRIGHT",
                            },
                        },
                        relativepoint = {
                            type = 'text',
                            name = "Relative Point",
                            usage = "<name>",
                            desc = "Select the point the buttons are relative to",
                            order = 20,
                            get = function()
                                return uab.db.profile.position.default.relpoint
                            end,
                            set = function(pt)
                                uab.db.profile.position.default.relpoint = pt
                            end,
                            validate = {
                                "cursor",
                                "screen",
                                "BOTTOM",
                                "BOTTOMLEFT",
                                "BOTTOMRIGHT",
                                "CENTER",
                                "LEFT",
                                "RIGHT",
                                "TOP",
                                "TOPLEFT",
                                "TOPRIGHT",
                            },
                        },
                        horizontal = {
                            type = 'text',
                            name = "Horizontal",
                            desc = "Horizontal offset (positive is right, negative is left, 0 is over cursor)",
                            usage = "<number>",
                            order = 30,
                            get = function()
                                return uab.db.profile.position.default.x
                            end,
                            set = function(value)
                                local v = tonumber(value)
                                v = math.floor(v)
                                uab.db.profile.position.default.x = v
                                uab.main:PositionChanged()
                            end,
                            validate = function(value)
                                local v = tonumber(value)
                                v = math.floor(v)
                                if tostring(v) == value then
                                    return true
                                end
                            end,
                        },
                        vertical = {
                            type = 'text',
                            name = "Vertical",
                            desc = "Vertical offset (positive is up, negative is down, 0 is over cursor)",
                            usage = "<number>",
                            order = 40,
                            get = function()
                                return uab.db.profile.position.default.y
                            end,
                            set = function(value)
                                local v = tonumber(value)
                                v = math.floor(v)
                                uab.db.profile.position.default.y = value
                                uab.main:PositionChanged()
                            end,
                            validate = function(value)
                                local v = tonumber(value)
                                v = math.floor(v)
                                if tostring(v) == value then
                                    return true
                                end
                            end,
                        },
                    },
                },
                                        
                groupanchorscale = {
                    type = 'group',
                    name = "Groups",
                    desc = "Anchor, scale, and behavior information for each unit group",
                    order = 40,
                    args  = {},
                },
                
                framegroups = {
                    type = 'group',
                    name = "Frame groups",
                    desc = "Frame groupings.  Enable/disable frames for UAB support, and define the anchor, scale, and behavior information for each frame group",
                    disabled = function() return InCombatLockdown() end,
            		order = 55,
                    args = {},
                },
                
                spacing3 = {
            		name = " ",
            		type = 'header',
            		order = 56,
            	},
            
                behaviorhdr = {
            		name = "Global Behavior",
            		type = 'header',
            		order = 57,
            	},

                directcast = {
                    type = 'toggle',
                    name = "Direct cast",
                    desc = "Use direct click-casting when action set contains a single action",
                    order = 60,
                    get = function()
                        return uab.db.profile.directcast
                    end,
                    set = function(v)
                        uab.db.profile.directcast = v
                        uab.main:DirectCastChanged()
                    end,
                },
                tooltip = {
                    type = 'toggle',
                    name = "Tooltips",
                    desc = "Show action tooltips",
            		order = 70,
                    get = function()
                        return uab.db.profile.tooltips
                    end,
                    set = function(v)
                        uab.db.profile.tooltips = v
                    end,
                },
                stayopen = {
                    type = 'toggle',
                    name = "Stay open",
                    desc = "Keep actions displayed after use.  Clicking cancel closes actions",
            		order = 80,
                    get = function()
                        return uab.db.profile.stayopen
                    end,
                    set = function(v)
                        uab.db.profile.stayopen = v
                        uab.main:StayOpenChanged()
                    end,
                },
                fastchangeunit = {
                    type = 'toggle',
                    name = "Fast change unit",
                    desc = "When selected, clicking on a different unit frame when action buttons are already shown will immediately reposition the buttons to the new unit frame and associate any action with that unit.  When not selected, clicking a new unit frame closes the action buttons",
            		order = 90,
                    get = function()
                        return uab.db.profile.fastchangeunit
                    end,
                    set = function(v)
                        uab.db.profile.fastchangeunit = v
                        uab.main:FastChangeUnitChanged()
                    end,
                },
            }
    	},
    
        unitstatus = {
            type = 'group',
            name = "Unit Status",
            desc = "Unit status settings",
            disabled = function() return InCombatLockdown() end,
    		order = 40,
            args = {},
    	},

        settings = {
            type = 'group',
            name = "Settings",
            desc = "Button indicator settings",
            disabled = function() return InCombatLockdown() end,
            order = 80,
            args = {
                highlight = {
                    type = 'range',
                    name = "Highlight Width",
                    desc = "Width of the highlight border, when active.",
                    order = 10,
                    min = 1,
                    max = 5,
                    step = 1,
                    isPercent = false,
                    get = function()
                        return uab.db.profile.borderwidth
                    end,
                    set = function(value)
                        uab.db.profile.borderwidth = value
                        uab.main:HighlightBorderChanged()
                    end,
                },
                blinkrate = {
                    type = 'range',
                    name = "Blink Rate",
                    desc = "The rate at which the action button blinks.  This is the complete cycle time from visible back to visible.",
                    order = 20,
                    min = 0.1,
                    max = 2.0,
                    step = 0.1,
                    isPercent = false,
                    get = function()
                        return uab.db.profile.blinkcycle
                    end,
                    set = function(value)
                        uab.db.profile.blinkcycle = value
                    end,
                },
                lowalpha = {
                    type = 'range',
                    name = "Low alpha",
                    desc = "The alpha value to use when displaying a button with low alpha.",
                    order = 30,
                    min = 0.05,
                    max = 1.0,
                    step = 0.05,
                    isPercent = false,
                    get = function()
                        return uab.db.profile.alpha
                    end,
                    set = function(value)
                        uab.db.profile.alpha = value
                    end,
                },
                checkusable = {
                    type = 'toggle',
                    name = "Check Usable",
                    desc = "When checked, examine whether an action is usable, and if not usable, show as unusable in addition to other action button indicators.",
                    order = 40,
                    get = function()
                        return uab.db.profile.checkusable
                    end,
                    set = function(value)
                        uab.db.profile.checkusable = value
                    end,
                },
            },
        },
    },
}

function uab.DropDownSelect(frame, functionData)
    frame[functionData.func](frame, this, functionData.arg1, functionData.arg2, functionData.arg3)
end

function uab.GroupIterate(fcn, self, context)
    local key, val
    for key, val in pairs(uab.constants.groupInfo) do
        local result = fcn and fcn(self, context, key, val)
        if result then
            return result
        end
    end
end

function uab:OnInitialize()
    self:RegisterDefaults('profile', self.profileDefaults)

    -- Clear debug message table
    UABDebug = {}

    self:SetupOffsetOptions()
    
	local layouts = {}

    local managers = uab:GetManagers()

	for _, mgr in pairs(managers) do
	    table.insert(layouts, mgr.manager:GetDisplayName())
	end

	self.options.args.lookandfeel.args.layout.args.select.validate = layouts

	self.main = uab.classes.main:new()
    
    --uabFrameGroup:RefreshFrameGroupList()
	
    self:RegisterChatCommand({ "/unitactionbars", "/uab" }, self.options)
	self.OnMenuRequest = self.options
end

function uab:SetupOffsetOptions()
    uab.GroupIterate(
        function(self, context, name, info)
            context.count = context.count + 1
            uab.options.args.lookandfeel.args.groupanchorscale.args[info.name] = {
                type = 'group',
                name = info.displayName,
                desc = "Set the position, scale, and behavior, for the action buttons when related to frames in the "..info.displayName.." group",
                order = context.count,
                args = {
                    independent = {
                        type = 'toggle',
                        name = "Independent show/hide",
                        desc = "When set, action buttons for the "..info.displayName.." group (regardless of action set) show and hide indepedently from other groups.",
                        order = 1,
                        get = function()
                            return uab.db.profile.independent[info.name]
                        end,
                        set = function(v)
                        	uab.db.profile.independent[info.name] = v
                            uab.main:SecureHeaderChanged(info.name)
                        end,
                    },
                    stayopen = {
		                type = 'text',
		                name = "Stay open",
                        desc = "Specify the show/hide behavior of the action buttons for the "..info.displayName.." group when clicked.",
		                order = 5,
		                get = function()
		                	if not uab.db.profile.groupstayopen[info.name] then
                                return "Use default"
                            end
                            
                            if uab.db.profile.groupstayopen[info.name].enabled then
                            	return "Yes"
                            else
                            	return "No"
                            end
                        end,
                        set = function(v)
                        	if v == "Use default" then
                                uab.db.profile.groupstayopen[info.name] = nil
                        	elseif v == "Yes" then
                                uab.db.profile.groupstayopen[info.name] = { enabled = true }
                        	else
                                uab.db.profile.groupstayopen[info.name] = {}
                        	end

                            uab.main:StayOpenChanged(info.name)
                        end,
                        validate = {
                        	"Yes",
                        	"No",
                        	"Use default",
                        },
                    },
                    spacing1 = {
                		name = " ",
                		type = 'header',
                		order = 6,
                	},
                
                    usedefaultscale = {
                        type = 'toggle',
                        name = "Default scale",
                        desc = info.displayName.." should use default scale value",
                        order = 10,
                        get = function()
                            return uab.db.profile.scale[info.name].usedefault
                        end,
                        set = function(v)
                            if not v then
                                if not uab.db.profile.scale[info.name].value then
                                    uab.db.profile.scale[info.name].value = uab.db.profile.scale.default.value
                                end
                            end
                        
                            uab.db.profile.scale[info.name].usedefault = v
                            uab.main:ScaleChanged(info.name)
                        end,
                    },
                    usedefaultanchor = {
                        type = 'toggle',
                        name = "Default anchor",
                        desc = info.displayName.." should use default action button anchor information",
                        order = 20,
                        get = function()
                            return uab.db.profile.position[info.name].usedefault
                        end,
                        set = function(v)
                            if not v then
                                if not uab.db.profile.position[info.name].point then
                                    uab.db.profile.position[info.name].point = uab.db.profile.position.default.point
                                end
                                
                                if not uab.db.profile.position[info.name].relpoint then
                                    uab.db.profile.position[info.name].relpoint = uab.db.profile.position.default.relpoint
                                end
                                
                                if not uab.db.profile.position[info.name].x then
                                    uab.db.profile.position[info.name].x = uab.db.profile.position.default.x
                                end
                                
                                if not uab.db.profile.position[info.name].y then
                                    uab.db.profile.position[info.name].y = uab.db.profile.position.default.y
                                end
                            end
                            uab.db.profile.position[info.name].usedefault = v
                            uab.main:PositionChanged(info.name)
                        end,
                    },
                    
                    spacing3 = {
                		name = " ",
                		type = 'header',
                		order = 30,
                	},
                
                    scale = {
                        type = 'range',
                        name = "Scale",
                        desc = info.displayName.. " action button scale",
                        disabled = function() return uab.db.profile.scale[info.name].usedefault end,
                        order = 40,
                        min = 0.05,
                        max = 2.00,
                        step = 0.05,
                        isPercent = true,
                        get = function()
                            return uab.db.profile.scale[info.name].value or uab.db.profile.scale.default.value
                        end,
                        set = function(value)
                            uab.db.profile.scale[info.name].value = value
                            uab.main:ScaleChanged(info.name)
                        end,
                    },
                    point = {
                        type = 'text',
                        name = "Point",
                        desc = "Select the point on the cancel button that positioning in based from for the "..info.displayName.." group",
                        disabled = function() return uab.db.profile.position[info.name].usedefault end,
                        order = 50,
                        get = function()
                            return uab.db.profile.position[info.name].point or uab.db.profile.position.default.point or "CENTER"
                        end,
                        set = function(pt)
                            uab.db.profile.position[info.name].point = pt
                            uab.main:PositionChanged(info.name)
                        end,
                        validate = {
                            "BOTTOM",
                            "BOTTOMLEFT",
                            "BOTTOMRIGHT",
                            "CENTER",
                            "LEFT",
                            "RIGHT",
                            "TOP",
                            "TOPLEFT",
                            "TOPRIGHT",
                        },
                    },
                    relativepoint = {
                        type = 'text',
                        name = "Relative Point",
                        desc = "Select the point the buttons are relative to for the "..info.displayName.." group",
                        disabled = function() return uab.db.profile.position[info.name].usedefault end,
                        order = 60,
                        get = function()
                            return uab.db.profile.position[info.name].relpoint or uab.db.profile.position.default.relpoint or "cursor"
                        end,
                        set = function(pt)
                            uab.db.profile.position[info.name].relpoint = pt
                            uab.main:PositionChanged(info.name)
                        end,
                        validate = {
                            "cursor",
                            "screen",
                            "BOTTOM",
                            "BOTTOMLEFT",
                            "BOTTOMRIGHT",
                            "CENTER",
                            "LEFT",
                            "RIGHT",
                            "TOP",
                            "TOPLEFT",
                            "TOPRIGHT",
                        },
                    },
                    horizontal = {
                        type = 'text',
                        name = "Horizontal",
                        desc = "Horizontal offset (positive is right, negative is left, 0 is over cursor) for the "..info.displayName.." group",
                        disabled = function() return uab.db.profile.position[info.name].usedefault end,
                        usage = "<number>",
                        order = 70,
                        get = function()
                            return uab.db.profile.position[info.name].x or uab.db.profile.position.default.x
                        end,
                        set = function(value)
                            local v = tonumber(value)
                            v = math.floor(v)
                            uab.db.profile.position[info.name].x = v
                            uab.main:PositionChanged(info.name)
                        end,
                        validate = function(value)
                            local v = tonumber(value)
                            v = math.floor(v)
                            if tostring(v) == value then
                                return true
                            end
                        end,
                    },
                    vertical = {
                        type = 'text',
                        name = "Vertical",
                        desc = "Vertical offset (positive is up, negative is down, 0 is over cursor) for the "..info.displayName.." group",
                        disabled = function() return uab.db.profile.position[info.name].usedefault end,
                        usage = "<number>",
                        order = 80,
                        get = function()
                            return uab.db.profile.position[info.name].y or uab.db.profile.position.default.y
                        end,
                        set = function(value)
                            local v = tonumber(value)
                            v = math.floor(v)
                            uab.db.profile.position[info.name].y = v
                            uab.main:PositionChanged(info.name)
                        end,
                        validate = function(value)
                            local v = tonumber(value)
                            v = math.floor(v)
                            if tostring(v) == value then
                                return true
                            end
                        end,
                    },
                },
            }
        end,
        nil,
        { count = 100 })
end

function uab:SetupUnitEffectOptions()
    local sorted = {}
	local unitEffects = self:GetAllUnitEffects()

	for name, _ in pairs(unitEffects) do
        table.insert(sorted, name)
    end

    table.sort(sorted)
    
    if not self.db.profile.priority then
        self.db.profile.priority = {}
    end

    if not self.db.profile.highlight then
		self.db.profile.highlight = {}
    end

    self.options.args.unitstatus.args = {}
    
    for idx = 1, # sorted, 1 do
        local name = sorted[idx]
        local instance = unitEffects[name]
        
        if not self.db.profile.priority[name] then
            self.db.profile.priority[name] = 50
        end

        if not self.db.profile.highlight[name] then
            self.db.profile.highlight[name] = instance:GetDefaultHighlightColor()
        end

        self.options.args.unitstatus.args[name] = {
            type = 'group',
            name = instance:GetDisplayName(),
            desc = "Settings for the "..instance:GetDisplayName().." unit status.",
            order = idx,
            args = {
                priority = {
                    type = 'range',
                    name = "Priority",
                    desc = instance:GetDisplayName() .. " priority",
                    disabled = function() return name == "default" end,
                    order = 1,
                    min = 1,
                    max = 100,
                    step = 1,
                    isPercent = false,
                    get = function()
                        return uab.db.profile.priority[name]
                    end,
                    set = function(value)
                        uab.db.profile.priority[name] = value
                    end,
                },
                highlight = {
                    type = 'color',
                    name = "Border highlight color",
                    desc = "Set the border hightlight color when "..instance:GetDisplayName().." is in effect",
                    order = 2,
                    get = function()
                        local c = uab.db.profile.highlight[name]
                        return c.r, c.g, c.b, c.a
                    end,
                    set = function(r, g, b, a)
                        local c = uab.db.profile.highlight[name]
                        c.r, c.g, c.b, c.a = r, g, b, a
                    end,
                    hasAlpha = true,
                },
            }
        }
	end
end

function uab:RefreshActivatorList()
	local order = 10

	local names = {}
	for key, val in pairs(self.db.profile.activators) do
	    table.insert(names, key)
	end

	table.sort(names)

	self.options.args.actionsets.args = {}

    self.options.args.actionsets.args.setup = {
        type = 'execute',
        name = "Setup",
        desc = "Setup action sets and action buttons for each action set",
        func = function()
            UAB_MainFrame:Show()
        end,
		order = 10,
    }
	
    self.options.args.actionsets.args.spacing1 = {
		name = " ",
		type = 'header',
		order = 20,
	}

    self.options.args.actionsets.args.new = {
        type = 'text',
        name = "New",
        desc = "Create a new action set",
        disabled = function() return not uab.main:FindNextAvailableActivation() end,
        usage = "<name>",
        order = 30,
        get = function() return end,
        set = function(name) uab.main:NewActivator(name) end,
        validate = function(name) return not uab.main:ActivatorExists(name) end,
    }

    self.options.args.actionsets.args.remove = {
        type = 'text',
        name = "Remove",
        desc = "Remove an existing action set",
        disabled = function() return not uab.main:AnyActivators() end,
        usage = "<name>",
        order = 40,
        get = function() end,
        set = function(name) uab.main:RemoveActivator(name) end,
        validate = function(name)
			if uab.db.profile.activators[name] then
				return true
			end
        end,
    }

    if # names > 0 then    
        self.options.args.actionsets.args.spacing2 = {
    		name = " ",
    		type = 'header',
    		order = 50,
    	}
    
        order = 100
        for idx = 1, # names, 1 do
            self.options.args.actionsets.args[names[idx]] = self:CreateActionSetOption(names[idx])
            self.options.args.actionsets.args[names[idx]].order = order
            order = order + 1
        end
    end
end

function uab:CreateActionSetOption(name, order)
    local options
    
    options = {
        type = 'group',
        name = name,
        desc = "Mouse activation settings for actions in the "..name.." action set",
        args = {
            active = {
                type = 'toggle',
                name = "Active",
                desc = "Activate this action set",
        		order = 10,
                get = function()
                    return uab.main:GetActivator(name):Enabled()
                end,
                set = function(v)
                    if v and not uab.main:GetActivator(name):Enabled() then
                        uab.main:EnableActivator(name)
                    elseif not v and uab.main:GetActivator(name):Enabled() then
                        uab.main:DisableActivator(name)
                    end
                end,
            },
        
            spacing1 = {
        		name = " ",
        		type = 'header',
        		order = 20,
        	},
	
            button = {
                type = 'text',
                name = "Button",
                desc = "Select the button to use to activate this action set",
                order = 30,
                get = function()
                    local btn = uab.db.profile.activators[name].button

                    if btn == "LeftButton" then
                        return "left"
                    end

                    if btn == "RightButton" then
                        return "right"
                    end

                    if btn == "MiddleButton" then
                        return "middle"
                    end

                    if btn == "Button4" then
                        return "button4"
                    end

                    return "button5"
                end,
                set = function(button)
                    local btn
                    if button == "left" then
                        btn = "LeftButton"
                    elseif button == "right" then
                        btn = "RightButton"
                    elseif button == "middle" then
                        btn = "MiddleButton"
                    elseif button == "button4" then
                        btn = "Button4"
                    elseif button == "button5" then
                        btn = "Button5"
                    end

                    if btn then
                        uab.main:SetActivatorButton(name, btn)
                    end
                end,

                validate = {"left", "right", "middle", "button4", "button5" }
            },
            keys = {
                type = 'group',
                name = "Keys",
                desc = "Keys that must be pressed for mouse activation",
                order = 40,
                args  = {
                    alt = {
                        type = 'toggle',
                        name = "Alt",
                        desc = "Alt key must be pressed",
						order = 1,
                        get = function()
                            return uab.db.profile.activators[name].prefixalt
                        end,
                        set = function(v)
                            if v then
                                uab.main:AddActivatorKey(name, "alt")
                            else
                                uab.main:RemoveActivatorKey(name, "alt")
                            end
                        end,
                    },
                    ctrl = {
                        type = 'toggle',
                        name = "Ctrl",
                        desc = "Ctrl key must be pressed",
						order = 2,
                        get = function()
                            return uab.db.profile.activators[name].prefixctrl
                        end,
                        set = function(v)
                            if v then
                                uab.main:AddActivatorKey(name, "ctrl")
                            else
                                uab.main:RemoveActivatorKey(name, "ctrl")
                            end
                        end,
                    },
                    shift = {
                        type = 'toggle',
                        name = "Shift",
                        desc = "Shift key must be pressed",
						order = 3,
                        get = function()
                            return uab.db.profile.activators[name].prefixshift
                        end,
                        set = function(v)
                            if v then
                                uab.main:AddActivatorKey(name, "shift")
                            else
                                uab.main:RemoveActivatorKey(name, "shift")
                            end
                        end,
                    },
				    spacing1 = {
						type = 'header',
						name = " ",
						order = 4,
					},
                    clear = {
                        type = 'execute',
                        name = "Clear",
                        desc = "Clear all prefix keys",
						order = 5,
                        func = function()
                            uab.main:ClearActivatorKeys(name)
                        end,
                    },
                },
            },
        
            spacing2 = {
        		name = " ",
        		type = 'header',
        		order = 50,
        	},
	
            spacing3 = {
        		name = "Indicators",
        		type = 'header',
        		order = 51,
        	},
	
            partyraid = {
                type = 'group',
                name = "Party/Raid",
                desc = "Action button indicators for the party/raid unit group of this action set.",
                order = 60,
                args  = {
                    action1 = {
                        type = 'group',
                        name = "Action 1",
                        desc = "Indicators for this action.",
                        order = 60,
                        args  = {
                        },
                    },
                },
            },
	
            player = {
                type = 'group',
                name = "Player",
                desc = "Action button indicators for the player unit group of this action set.",
                order = 61,
                args  = {
                },
            },
	
            tottarget = {
                type = 'group',
                name = "ToT Target",
                desc = "Action button indicators for the ToT target unit group of this action set.",
                order = 62,
                args  = {
                },
            },
	
            focus = {
                type = 'group',
                name = "Focus",
                desc = "Action button indicators for the focus unit group of this action set.",
                order = 63,
                args  = {
                },
            },
	
            target = {
                type = 'group',
                name = "Target",
                desc = "Action buttons for the target unit group of this action set.",
                order = 64,
                args  = {
                },
            },
	
            focustarget = {
                type = 'group',
                name = "Focus Target",
                desc = "Action buttons for the focus target unit group of this action set.",
                order = 65,
                args  = {
                },
            },
	
            pet = {
                type = 'group',
                name = "Pet",
                desc = "Action buttons for the pet unit group of this action set.",
                order = 66,
                args  = {
                },
            },
	
            targettarget = {
                type = 'group',
                name = "Focus",
                desc = "Action buttons for the target target unit group of this action set.",
                order = 67,
                args  = {
                },
            },
        },
    }
    
    return options
end

function uab:RefreshFrameGroupList()
	local order = 10

	local names = {}
	for key, val in pairs(self.db.profile.framegroups) do
	    table.insert(names, key)
	end

	table.sort(names)

	self.options.args.lookandfeel.args.framegroups.args = {}

    self.options.args.lookandfeel.args.framegroups.args.new = {
        type = 'text',
        name = "New",
        desc = "Add a new frame group.  Any frame that matches the expression associated with this group will use the anchor and scale configuration for the group",
        usage = "<name>",
        order = 10,
        get = function() return end,
        set = function(name) uab.main:NewFrameGroup(name) end,
        validate = function(name) return not uab.main:FrameGroupExists(name) end,
    }

    self.options.args.lookandfeel.args.framegroups.args.remove = {
        type = 'text',
        name = "Remove",
        desc = "Remove an existing frame group",
        usage = "<name>",
        order = 40,
        get = function() end,
        set = function(name) uab.main:RemoveFrameGroup(name) end,
        validate = function(name)
            if uab.db.profile.framegroups[name] then
                return true
            end
        end,
    }

    if # names > 0 then    
        self.options.args.lookandfeel.args.framegroups.args.spacing2 = {
    		name = " ",
    		type = 'header',
    		order = 50,
    	}
    
        order = 100
        for idx = 1, # names, 1 do
            self.options.args.lookandfeel.args.framegroups.args[names[idx]] = self:CreateFrameGroupOption(names[idx])
            self.options.args.lookandfeel.args.framegroups.args[names[idx]].order = order
            order = order + 1
        end
    end
end

function uab:CreateFrameGroupOption(name)
    local options
    
    options = {
        type = 'group',
        name = name,
        desc = "Use, anchor, scale, and match expression for frames in the "..name.." frame group",
        args = {
            enabled = {
                type = 'toggle',
                name = "Enabled",
                desc = "When checked, enable the use of UAB action sets for frames in the "..name.." frame group",
                order = 1,
                get = function()
                    return not uab.db.profile.framegroups[name].disabled
                end,
                set = function(v)
                    uab.db.profile.framegroups[name].disabled = not v
                    uab.main:SetFrameGroupFrameEnabledStates()
                end,
            },
            
            expression = {
                type = 'text',
                name = "Expression",
                usage = "<expression>",
                desc = "Define the match expression for frames in this frame group.  Any frame that has a name that matches this expression will use the anchor and scale settings defined for this frame group",
                order = 2,
                get = function()
                    return uab.db.profile.framegroups[name].expression
                end,
                set = function(exp)
                    uab.main:SetFrameGroupExpression(name, exp)
                end,
            },
            
            spacing3 = {
                name = " ",
                type = 'header',
                order = 5,
            },
        
            usedefaultscale = {
                type = 'toggle',
                name = "Default scale",
                desc = "Frames in the "..name.." frame group should use the default scale value",
                order = 10,
                get = function()
                    return uab.db.profile.framegroups[name].usedefaultscale
                end,
                set = function(v)
                    if not v then
                        if not uab.db.profile.framegroups[name].scale then
                            uab.db.profile.framegroups[name].scale = uab.db.profile.scale.default.value
                        end
                    end
                
                    uab.db.profile.framegroups[name].usedefaultscale = v
                    uab.main:ScaleChanged()
                end,
            },
            usedefaultanchor = {
                type = 'toggle',
                name = "Default anchor",
                desc = "Frames in the "..name.." frame group should use the default action button anchor information",
                order = 20,
                get = function()
                    return uab.db.profile.framegroups[name].usedefaultanchor
                end,
                set = function(v)
                    if not v then
                        if not uab.db.profile.framegroups[name].point then
                            uab.db.profile.framegroups[name].point = uab.db.profile.position.default.point
                        end
                        
                        if not uab.db.profile.framegroups[name].relpoint then
                            uab.db.profile.framegroups[name].relpoint = uab.db.profile.position.default.relpoint
                        end
                        
                        if not uab.db.profile.framegroups[name].x then
                            uab.db.profile.framegroups[name].x = uab.db.profile.position.default.x
                        end
                        
                        if not uab.db.profile.framegroups[name].y then
                            uab.db.profile.framegroups[name].y = uab.db.profile.position.default.y
                        end
                    end
                    uab.db.profile.framegroups[name].usedefaultanchor = v
                    uab.main:PositionChanged(name)
                end,
            },
            
            spacing3 = {
                name = " ",
                type = 'header',
                order = 30,
            },
        
            scale = {
                type = 'range',
                name = "Scale",
                desc = "Scale for frames in the "..name.." frame group",
                disabled = function() return uab.db.profile.framegroups[name].usedefaultscale end,
                order = 40,
                min = 0.05,
                max = 2.00,
                step = 0.05,
                isPercent = true,
                get = function()
                    return uab.db.profile.framegroups[name].scale or uab.db.profile.scale.default.value
                end,
                set = function(value)
                    uab.db.profile.framegroups[name].scale = value
                    uab.main:ScaleChanged()
                end,
            },
            point = {
                type = 'text',
                name = "Point",
                desc = "Select the point on the cancel button that positioning in based from for frames in the "..name.." frame group",
                disabled = function() return uab.db.profile.framegroups[name].usedefaultanchor end,
                order = 50,
                get = function()
                    return uab.db.profile.framegroups[name].point or uab.db.profile.position.default.point or "CENTER"
                end,
                set = function(pt)
                    uab.db.profile.framegroups[name].point = pt
                    uab.main:PositionChanged(name)
                end,
                validate = {
                    "BOTTOM",
                    "BOTTOMLEFT",
                    "BOTTOMRIGHT",
                    "CENTER",
                    "LEFT",
                    "RIGHT",
                    "TOP",
                    "TOPLEFT",
                    "TOPRIGHT",
                },
            },
            relativepoint = {
                type = 'text',
                name = "Relative Point",
                desc = "Select the point the buttons are relative to for the frames in the "..name.." frame group",
                disabled = function() return uab.db.profile.framegroups[name].usedefaultanchor end,
                order = 60,
                get = function()
                    return uab.db.profile.framegroups[name].relpoint or uab.db.profile.position.default.relpoint or "cursor"
                end,
                set = function(pt)
                    uab.db.profile.framegroups[name].relpoint = pt
                    uab.main:PositionChanged()
                end,
                validate = {
                    "cursor",
                    "screen",
                    "BOTTOM",
                    "BOTTOMLEFT",
                    "BOTTOMRIGHT",
                    "CENTER",
                    "LEFT",
                    "RIGHT",
                    "TOP",
                    "TOPLEFT",
                    "TOPRIGHT",
                },
            },
            horizontal = {
                type = 'text',
                name = "Horizontal",
                desc = "Horizontal offset (positive is right, negative is left, 0 is over cursor) for frames in the "..name.." frame group",
                disabled = function() return uab.db.profile.framegroups[name].usedefaultanchor end,
                usage = "<number>",
                order = 70,
                get = function()
                    return uab.db.profile.framegroups[name].x or uab.db.profile.position.default.x
                end,
                set = function(value)
                    local v = tonumber(value)
                    v = math.floor(v)
                    uab.db.profile.framegroups[name].x = v
                    uab.main:PositionChanged(name)
                end,
                validate = function(value)
                    local v = tonumber(value)
                    v = math.floor(v)
                    if tostring(v) == value then
                        return true
                    end
                end,
            },
            vertical = {
                type = 'text',
                name = "Vertical",
                desc = "Vertical offset (positive is up, negative is down, 0 is over cursor) for frames in the "..name.." frame group",
                disabled = function() return uab.db.profile.framegroups[name].usedefaultanchor end,
                usage = "<number>",
                order = 80,
                get = function()
                    return uab.db.profile.framegroups[name].y or uab.db.profile.position.default.y
                end,
                set = function(value)
                    local v = tonumber(value)
                    v = math.floor(v)
                    uab.db.profile.framegroups[name].y = v
                    uab.main:PositionChanged()
                end,
                validate = function(value)
                    local v = tonumber(value)
                    v = math.floor(v)
                    if tostring(v) == value then
                        return true
                    end
                end,
            },
        },
    }
    
    return options
end

function uab:OnEnable(first)
    if not self.db.profile.position.default.point then
        self.db.profile.position.default.point = "CENTER"
    end
    
    if not self.db.profile.position.default.relpoint then
        self.db.profile.position.default.relpoint = "cursor"
    end
    
    if not self.db.profile.position.default.x then
        self.db.profile.position.default.x = (self.db.profile.default.value and self.db.profile.default.value.x) or 0
    end
    
    if not self.db.profile.position.default.y then
        self.db.profile.position.default.y = (self.db.profile.default.value and self.db.profile.default.value.y) or 0
    end
    
    self.db.profile.position.default.value = nil
    
    self:SetupUnitEffectOptions()

	self:EnableModules()
	self.main:Enable()
end

function uab:OnDisable()
	self.main:Disable()
	self:DisableModules()
end

function uab:EnableModules()
	for name,module in self:IterateModules() do
		self:ToggleModuleActive(module, true)
	end
end

function uab:DisableModules()
	for name,module in self:IterateModules() do
		self:ToggleModuleActive(module, false)
	end
end

function uab:OnProfileEnable(oldName, oldProfileData)
    --[[
    Profile changed.  We need to reset all the click activators
    based on the new profile.  This could mean renaming some of
    the click activators, disabling others, and changing the set of
    actions for all groups inside each activator.
    --]]
    self:OnDisable()
    self:OnEnable()
end

function uab:OnTooltipUpdate()
	local cat = uab.mixins.tablet:AddCategory("columns", 1)
	cat:AddLine("header", "Unit Action Bars")

	uab.mixins.tablet:SetHint("|cffeda55fClick|r to configure.")
end

function uab:OnClick()
	if not InCombatLockdown() then
        UAB_MainFrame:Show()
    else
        uab.print("Configuration not allowed in combat")
    end
end

function uab:ResetButtons()
    self.main:ResetButtons()
end

function uab:ResetHeaders()
    self.main:ResetHeaders()
end

function uab:RegisterLayoutManager(managerClass)
	self.layoutManagers[managerClass] = {}
end

function uab:GetManagers()
	local managers = {}

	for managerClass, info in pairs(self.layoutManagers) do
	    if not info.manager then
	        info.manager = managerClass:new()
		end

		managers[info.manager:GetName()] = info
	end

	return managers
end

function uab:RegisterUnitEffect(effectClass)
	self.unitEffectClasses[effectClass] = {}
end

function uab:GetUnitEffect(effectName)
	if not self.unitEffectClassInstances[effectName] then
		for class, info in pairs(self.unitEffectClasses) do
			if not info.instance then
				info.instance = class:new()
				self.unitEffectClassInstances[info:GetName()] = info.instance
			end
			if info.instance:GetName() == effectName then
				break
			end
		end
	end

	return self.unitEffectClassInstances[effectName]
end

function uab:GetAllUnitEffects()
	for class, info in pairs(self.unitEffectClasses) do
		if not info.instance then
			info.instance = class:new()
			self.unitEffectClassInstances[info.instance:GetName()] = info.instance
		end
	end

	return self.unitEffectClassInstances
end

function uab.CloneTable(tbl)
	if type(tbl) == "table" then
        local newtbl = {}

        for val, data in pairs(tbl) do
            newtbl[val] = uab.CloneTable(data)
        end
        
        return newtbl
    elseif type(tbl) == "string" then
        return tbl
    elseif type(tbl) == "number" then
        return tbl
    elseif type(tbl) == "boolean" then
        return tbl
    end
end

function uab.DoStartMoving(frame, btn)
	if (btn == "LeftButton") then
		frame:SetUserPlaced(true)
		frame:StartMoving()
		frame.ismoving = true
	end
end
    			
function uab.DoStopMoving(frame)
	if (frame.ismoving) then
		frame:StopMovingOrSizing()
		frame:SetUserPlaced(true)
		frame.ismoving = nil
	end
end

